<?php

namespace HPROWP\Core;

/**
 * Default provider class
 * @author dzonz
 *
 */
class Initializer {

    private static $_instances = array();
    private static $_initializers = array();
    
    public static function register($initializer, $initializerClass = null) {
        self::$_initializers[$initializer] = $initializerClass ? $initializerClass : $initializer;
    }
    
    public static function initialize($instance, $config = null) {
        foreach (self::$_initializers as $initializer => $registeredInitializerClass) {
            if (!isset(self::$_instances[$initializer])) {
                $initializerInstance = new $registeredInitializerClass();
                self::$_instances[$initializer] = $initializerInstance;
            }
            
            if (self::$_instances[$initializer] instanceof InitializerInterface) {
                self::$_instances[$initializer]->initialize($instance);
            }
        }
    }

    protected function __construct() {
        
    }
    
}
