<?php

namespace HPROWP\Core;

/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/*
Default: bottom of menu structure #Default: bottom of menu structure
2 – Dashboard
4 – Separator
5 – Posts
10 – Media
15 – Links
20 – Pages
25 – Comments
59 – Separator
60 – Appearance
65 – Plugins
70 – Users
75 – Tools
80 – Settings
99 – Separator

For the Network Admin menu, the values are different: #For the Network Admin menu, the values are different:
2 – Dashboard
4 – Separator
5 – Sites
10 – Users
15 – Themes
20 – Plugins
25 – Settings
30 – Updates
99 – Separator
*/
class PagesInitializer 
implements InitializerInterface {
    
    public function initialize($instance) {
        if ($instance instanceof PagesInitializerInterface) {
            
            $callbackInitializer = new Callback(function (PagesInitializerInterface $instance, PagesInitializer $initializer) {
                $pages = $instance->getPages();
                $initializer->addPages($pages);
            }, array($instance, $this));
            
            $callbackInitializer->addAction('admin_menu', 11, 1);
        }
    }
    
    public function addPages($pages = array(), $parent = null) {
        foreach ($pages as $page) {
            if (isset($page['type'])) {
                switch ($page['type']) {
                    case 'options':
                    add_options_page(
                        isset($page['title']) ? $page['title'] : $page['label'], 
                        $page['label'], 
                        isset($page['capability']) ? $page['capability'] : 'manage_options', 
                        $page['slug'], 
                        $page['onRender']
                    );
                    break;
                default:
                    break;
                }

                continue;
            }

            if (isset($page['post_type'])) {
                switch ($page['post_type']) {
                    case 'attachment':
                        $parent = $parent ? $parent : 'upload.php';
                        $page['query'] = isset($page['query']) ? $page['query'] : 'upload.php';
                        $page['script'] = isset($page['script']) ? $page['script'] : 'upload.php';
                        break;
                    default:
                        $parent = $parent ? $parent : 'edit.php?post_type=' . $page['post_type'];
                        $page['query'] = isset($page['query']) ? $page['query'] : 'edit.php?post_type=' . $page['post_type'];
                        $page['script'] = isset($page['script']) ? $page['script'] : 'edit.php';
                        break;
                }
            }

            $pageHook = false;
            if ($parent) {
                $pageHook = $this->addSubPage($page, $parent);
            }
            else {
                $pageHook = $this->addPage($page);
            }
            
            if ($pageHook
                && isset($page['onLoad'])
            ) {
                add_action('load-' . $pageHook, $page['onLoad'], 10);
            }

            if (isset($page['pages'])) {
                $this->addPages($page['pages'], $page['slug']);
            }
        }
    }
    
    public function addPage($page = array()) {
        return add_menu_page(
            isset($page['title']) ? $page['title'] : $page['label'], 
            $page['label'], 
            10, 
            $page['slug'], 
            $page['onRender'], 
            isset($page['icon']) ? $page['icon'] : 'default',
            $page['position']
        );
    }
    
    public function addSubPage($page = array(), $parent = null) {
        return add_submenu_page(
            $parent, 
            isset($page['title']) ? $page['title'] : $page['label'], 
            $page['label'], 
            10, 
            $page['slug'], 
            $page['onRender']
        );
    }
}

