<?php

namespace HPROWP\Core;

/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

class ThemeInitializer 
implements InitializerInterface {
    
    public function initialize($instance) {
        if ($instance instanceof ThemeInitializerInterface) {
        // theme setup actions
            add_action('after_switch_theme', array(&$instance, 'themeSelect'), 11);
            add_action('switch_theme', array(&$instance, 'themeDeselect'), 11);
            add_action('setup_theme', array(&$instance, 'themeBootstrap'), 11);
            add_action('after_setup_theme', array(&$instance, 'themeSetup'), 11);

            // init action
            add_action('init', array(&$instance, 'themeInit'), 11);
            add_action('admin_init', array(&$instance, 'themeInitAdmin'), 11);
            add_action('admin_menu', array(&$instance, 'themeAdminMenu'), 11);

            // register widgets, menus, metaboxes, selectMenuItm
            add_filter('nav_menu_css_class', array(&$instance, 'navigationCssClass'), 11, 4);

            // template rules
            add_filter('rewrite_rules_array', array(&$instance, 'rewriteRules'), 11);

            // register script rendering
            add_action('admin_enqueue_scripts', array(&$instance, 'themeAdminScripts'), 11);
            add_action('admin_print_styles', array(&$instance, 'themeAdminStyles'), 11);

            add_action('wp_enqueue_scripts', array(&$instance, 'themePublicScripts'), 11);
            add_action('wp_enqueue_scripts', array(&$instance, 'themePublicStyles'), 11);
            add_action('wp_footer', array(&$instance, 'webpushImportScript'), 11);
        }
    }
    
}