<?php

namespace HPROWP\Webpush;

class BaseSettings {
    protected $settings = 'general';
    
    protected $optionsPage = 'horisen_webpush'; // 'my-setting-admin'
    
    protected $optionsGroup = 'horisen_webpush_group';
    protected $optionsKey = 'horisen_webpush_settings';
    protected $optionsSection = 'horisen_webpush_section';
    
    public function __construct() {
        $this->optionsPage = 'horisen_webpush_' . $this->settings; // 'my-setting-admin'
    
        $this->optionsGroup = 'horisen_webpush_' . $this->settings . '_group';
        $this->optionsKey = 'horisen_webpush_' . $this->settings . '_settings';
        $this->optionsSection = 'horisen_webpush_' . $this->settings . '_section';
    }
    
    public static function getOptions() {
        return get_option('horisen_webpush_button_settings', array() );
    }
    
    public function render() {
        $this->options = static::getOptions();
        ?>

        <div class="wrap">
            <h1><?php __('nGage', 'hpro-webpush' ); ?></h1>
            <div class="description"><?php __('nGage webpush SDK settings', 'hpro-webpush' ); ?></div>
            <?php if (empty($_SERVER['HTTPS'])) { ?>
                <div class="notice notice-error is-dismissible">
                    <p><?php _e('Plugin will not work properly!', 'hpro-webpush' ); ?></p>
                    <p><?php _e('Your site URL must begin with https://, and display a green lock icon on the browser\'s address bar', 'hpro-webpush' ); ?></p>
                </div>
            <?php } ?>
            <?php if( !file_exists(get_home_path(__FILE__) . 'service-worker.js')) { ?>
                <div class="notice notice-warning is-dismissible">
                    <p><?php _e("service-worker.js file doesn't exist!", 'hpro-webpush' ); ?></p>
                    <p><?php _e('Check documentation', 'hpro-webpush' ); ?> <a href="http://developers.staging.horisen.biz/en/ngage#typical-setup">link</a></p>
                </div>
            <?php } ?>
            
            <?php settings_errors(); ?> 
            
            <h2 class="nav-tab-wrapper">  
                <a href="?page=horisen_webpush_page_general&tab=general" class="nav-tab <?php echo $this->settings == 'general' ? 'nav-tab-active' : ''; ?>"><?php _e('General', 'hpro-webpush'); ?></a>  
                <a href="?page=horisen_webpush_page_notify_button&tab=notify_button" class="nav-tab <?php echo $this->settings == 'button' ? 'nav-tab-active' : ''; ?>"><?php _e('Notify button', 'hpro-webpush'); ?></a>  
            </h2>  

            <form method="post" action="options.php"> 
            <?php
                
            $this->renderSettings();
            submit_button(); 
            
            ?> 
            </form> 

        </div>
    <?php
    }
    
    protected function renderSettings() {
        settings_fields( $this->optionsGroup );
        do_settings_sections( $this->optionsPage );
    }
}