<?php

namespace HPROWP\Webpush\Validators;

class Validators {
    
    public function __construct() {
    }
    
    public function chain($fieldValue, $fieldKey, $prefix, $validatorsCallbackFunctions){
        $error = [];
        if(isset($validatorsCallbackFunctions)) $validatorsCallbackFunctions = [];
        
        foreach ($validatorsCallbackFunctions as $value) {
            if($value){
                array_push($error, $value);
            }
        };
        
        if ($error) {
            add_settings_error($fieldKey . '_error', $fieldKey , $prefix . ': ' . implode(',', $error), 'error');
        }else {
            return sanitize_text_field( $fieldValue );
        }
    }
    
    public function required($input){
        if(!isset($input) || strlen($input) == 0){
            return 'Field is required';
        }
    }
    public function characterLimit($input, $from, $to){
        if(strlen($input) < $from || strlen($input) > $to){
            return 'Wrong input';
        }
    }
    public function characterLimitIs($input, $limit){
        if(strlen($input) !== $limit){
            return 'Wrong input';
        }
    }
}
